
/*
  file serv_parse.c
  forked from serv_simple.c, dim. mai  3 20:05:32 CEST 2020

This is a basic, blocking HTTaP server, that serves
custom HTTaP commands (in addition to files)

Compile:
 gcc -DSHOW_CLIENT -DHTTAP_VERBOSE -Wall serv_parse.c -o serv_parse

run:  (if you have your index.html in the files/ subdirectory)
 export HTTAP_TCPPORT=60000
 export HTTAP_STATICPATH=files
 export HTTAP_ROOTPAGE=index_parse.html
 ./serv_parse

*/

// override defaults so you don't need to mess with HTTaP.h :
#define HTTAP_SERVE_FILES
#define HTTAP_SERVER_ID   "blocking server with HTTaP"
#define HTTAP_KEEPALIVE   (10)

// define our own HTTaP parser :
#define HTTAP_PARSE my_HTTaP_parser

int my_HTTaP_parser(
    char *request, // pointer to the request (receive buffer)
    int recv_len,  // byte count of the request
    int ReqType,   // 1 for GET, 2 for POST
    char *b,       // pointer to the send buffer
    int *len) {    // length of the send buffer

  return 0;
}

// Use the provided parachute
#define HTTAP_USE_SIGNAL

#include "HTTaP.h"

int main(int argc, char *argv[]) {
  int count=0;

  init_HTTaP(H_BLOCKED);

  do {
    HTTaP_manager();

    // show that something is happening:
    printf("%d \n", count++);
  } while (!abort_program);

  printf("bye from main() !");
  return EXIT_SUCCESS;
}
