
/* file HTTaP/src/manager.h
   created sam. avril 25 14:57:58 CEST 2020 by whygee@f-cpu.org
   version lun. avril 27 16:01:16 CEST 2020 : keepalive_counter removed
   version lun. mai  4 01:20:22 CEST 2020 : H_timediff moved here (so HTTaP.c can use it)
  definitions and declarations for the management layer of HTTP.
*/


#ifndef H_HTTAP_MANAGER_H
#define H_HTTAP_MANAGER_H

typedef enum {
// When there is host work to do, don't wait at the poll() call (timeout=0)
  H_POLL_SLOW = 1, // Poll slowly when there is no interactive activity
  H_POLL_FAST = 2, // Poll more often when some activity has been detected

// When there is no work to do, "block" at the poll() call
  H_BLOCKING  = 4, // Activity has been recently received, timeout has not yet elapsed.
    // => timeout is recalculated based on previous timestamp gotten from clock_gettime().
  H_BLOCKED   = 8  // No connection or timeout, hard block and wait for signal
     // or incoming order.  => timeout = -1.
} PollState_e;
PollState_e PollState; // must be initialised by calling init_HTTaP()

struct itimerval itv_poll; // determines how long each host slice lasts

struct timespec timestamp; // Time when the keepalive expires

// These are somehow related but i can't merge them yet
int H_timediff,     // nb of seconds until timeout
    H_poll_timeout; // millisecond to be waited in poll() by the server
void get_time_diff(); // updates H_timediff

///////////// API : /////////////

// Mailbox for the polling timer:
volatile unsigned int timeout_counter=0;

int abort_program=0,   // flag to be read by idling loop
    keepalive_seconds; // value read from the #define's and the environment variable

// user-visible prototypes
void HTTaP_mode_block();
void HTTaP_mode_poll();

#endif
